#include <stdio.h>
#include <imsls.h>

#define DEGREE           2
#define NOBS            14

int main()
{
    int         iset = 1, dfpe;
    float       *coefficients, *anova_table, sspe, *ssqpoly, *ssqlof;
    float       x[] = {0.0, 0.0, 1.0, 1.0, 2.0, 2.0, 4.0,
                       4.0, 5.0, 5.0, 6.0, 6.0, 7.0, 7.0};
    float       y[] = {508.1, 498.4, 568.2, 577.3, 651.7, 657.0, 755.3,
                       758.9, 787.6, 792.1, 841.4, 831.8, 854.7, 871.4};
    char        *coef_rlab[2];
    char        *coef_clab[] = {" ", "intercept", "linear", 
                                "quadratic"};
    char        *stat_clab[] = {" ", "Degrees of\nFreedom", 
                                "Sum of\nSquares", 
                                "\nF-Statistic", "\np-value"};
    char        *anova_rlab[] = {
                   "degrees of freedom for regression", 
                   "degrees of freedom for error", 
                   "total (corrected) degrees of freedom",
                   "sum of squares for regression", 
                   "sum of squares for error", 
                   "total (corrected) sum of squares",
                   "regression mean square", 
                   "error mean square", "F-statistic",
                   "p-value", "R-squared (in percent)", 
                   "adjusted R-squared (in percent)",
                   "est. standard deviation of model error", 
                   "overall mean of y", 
                   "coefficient of variation (in percent)"};

     coefficients = imsls_f_poly_regression(NOBS, x, y, DEGREE,
                                           IMSLS_SSQ_POLY, &ssqpoly,
                                           IMSLS_SSQ_LOF, &ssqlof,
                                           IMSLS_ANOVA_TABLE, &anova_table,
                                           IMSLS_DF_PURE_ERROR, &dfpe,
                                           IMSLS_SSQ_PURE_ERROR, &sspe,
                                           0);
    imsls_write_options(-1, &iset);
    imsls_f_write_matrix("Least Squares Polynomial Coefficients", 
                                            1, DEGREE + 1, 
                        coefficients, 
                        IMSLS_COL_LABELS, coef_clab,
                        0);
    coef_rlab[0] = coef_clab[2];
    coef_rlab[1] = coef_clab[3];
    imsls_f_write_matrix("Sequential Statistics", DEGREE, 4, ssqpoly, 
                        IMSLS_COL_LABELS, stat_clab,
                        IMSLS_ROW_LABELS, coef_rlab,
                        IMSLS_WRITE_FORMAT, "%3.1f%8.1f%6.1f%6.4f",
                        0);
    imsls_f_write_matrix("Lack-of-Fit Statistics", DEGREE, 4, ssqlof,
                        IMSLS_COL_LABELS, stat_clab,
                        IMSLS_ROW_LABELS, coef_rlab,
                        IMSLS_WRITE_FORMAT,  "%3.1f%8.1f%6.1f%6.4f",
                        0);
    imsls_f_write_matrix("* * * Analysis of Variance * * *\n", 15, 1,
                                                         anova_table,
                        IMSLS_ROW_LABELS, anova_rlab,
                        IMSLS_WRITE_FORMAT, "%9.2f",
                        0);
}
